diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/get_archive_args v15.6301-amd64/pop/com/get_archive_args
--- v15.63/pop/com/get_archive_args	1998-11-03 13:48:50.000000000 -0500
+++ v15.6301-amd64/pop/com/get_archive_args	2010-01-03 04:06:09.000000000 -0500
@@ -118,7 +118,7 @@
 		;;
 	elf_linux*)
 		LIBEXTN=.so
-		AR='gcc -shared -o $LIBNAME'
+		AR='gcc -g -shared -o $LIBNAME'
 		RANLIB=
 		;;
 	osf1*)
@@ -137,7 +137,10 @@
 # Output commands to set variables in caller shell -- this must be
 # eval'ed by the caller. AR and RANLIB must then be eval'ed after
 # setting LIBNAME.
-if [ $Shell = "csh" ]; then
+
+if [ "$Shell" == "csh" ]; then
+	echo "set CC='$CC'; set IDIRS='$IDIRS'; set CFLAGS='$CFLAGS'; set LIBEXTN='$LIBEXTN'; set AR='$AR'; set LDLIBS='$LDLIBS'; set RANLIB='$RANLIB'"
+elif [ "$Shell" == "tcsh" ]; then
 	echo "set CC='$CC'; set IDIRS='$IDIRS'; set CFLAGS='$CFLAGS'; set LIBEXTN='$LIBEXTN'; set AR='$AR'; set LDLIBS='$LDLIBS'; set RANLIB='$RANLIB'"
 else
 	echo "CC='$CC'; IDIRS='$IDIRS'; CFLAGS='$CFLAGS'; LIBEXTN='$LIBEXTN'; AR='$AR'; LDLIBS='$LDLIBS'; RANLIB='$RANLIB'"
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/mkXpw v15.6301-amd64/pop/com/mkXpw
--- v15.63/pop/com/mkXpw	1998-11-03 13:17:28.000000000 -0500
+++ v15.6301-amd64/pop/com/mkXpw	2005-03-11 05:30:38.000000000 -0500
@@ -18,7 +18,7 @@
 
 cd $usepop/pop/x/Xpw
 
-$CC -c $CFLAGS $IDIRS *.c   && \
+$CC -g -c $CFLAGS $IDIRS *.c   && \
 eval $AR *.o $LDLIBS        && \
 eval $RANLIB                && \
 rm *.o                      && \
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/mkstartup v15.6301-amd64/pop/com/mkstartup
--- v15.63/pop/com/mkstartup	2005-01-18 13:33:21.000000000 -0500
+++ v15.6301-amd64/pop/com/mkstartup	2005-03-13 17:09:38.000000000 -0500
@@ -16,7 +16,7 @@
 
 $popsys/basepop11 %nort %noinit \
 	$popliblib/mkimage.p \
-	-nodebug -nonwriteable -install $usepop/pop/lib/psv/startup.psv \
+	-nodebug  -install $usepop/pop/lib/psv/startup.psv \
 				popuseslist \
 				poppackagelist \
 				popxlib \
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/mkstartup.bham v15.6301-amd64/pop/com/mkstartup.bham
--- v15.63/pop/com/mkstartup.bham	2005-01-18 13:33:21.000000000 -0500
+++ v15.6301-amd64/pop/com/mkstartup.bham	2005-03-13 17:09:38.000000000 -0500
@@ -16,7 +16,7 @@
 
 $popsys/basepop11 %nort %noinit \
 	$popliblib/mkimage.p \
-	-nodebug -nonwriteable -install $usepop/pop/lib/psv/startup.psv \
+	-nodebug  -install $usepop/pop/lib/psv/startup.psv \
 				popuseslist \
 				poppackagelist \
 				popxlib \
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/mkxved v15.6301-amd64/pop/com/mkxved
--- v15.63/pop/com/mkxved	1995-08-22 10:45:38.000000000 -0400
+++ v15.6301-amd64/pop/com/mkxved	2005-03-13 17:20:43.000000000 -0500
@@ -1,4 +1,5 @@
-# --- Copyright University of Sussex 1995. All rights reserved. ----------
+#!/bin/sh
+# --- Copyright University of Sussex 2005. All rights reserved. ----------
 # File:             C.unix/com/mkxved
 # Purpose:          Make an XVed saved image
 # Author:           Robert John Duncan, Aug 20 1991 (see revisions)
@@ -6,13 +7,15 @@
 
 $popsys/pop11 %nort %noinit \
 	$popliblib/mkimage.p \
-	-nodebug -nonwriteable -install -entry xved_standalone_setup \
+	-nodebug -install -entry xved_standalone_setup \
 	$popsavelib/xved.psv \
 	mkxved
 
 rm -f $popsavelib/xved.psv-
 
 # --- Revision History ---------------------------------------------------
+# --- Aaron Sloman, Mar 13 2005
+#	             removed -nonwriteable
 # --- John Gibson, Aug 22 1995  Added %noinit
 # --- John Gibson, Jun  3 1993  Added -nodebug -nonwriteable
 # --- John Gibson, Jan 21 1993  Changed to use -entry
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/mkxvedpro v15.6301-amd64/pop/com/mkxvedpro
--- v15.63/pop/com/mkxvedpro	2005-01-17 07:24:58.000000000 -0500
+++ v15.6301-amd64/pop/com/mkxvedpro	2005-03-13 17:21:33.000000000 -0500
@@ -1,4 +1,7 @@
 #!/bin/sh
+# --- Copyright University of Birmingham 2005. All rights reserved. ------
+# Author:			Aaron Sloman, Mar 13 2005
+
 # --- Copyright University of Sussex 1991. All rights reserved. ----------
 ### --- Copyright University of Birmingham 2005.
 ### $usepop/pop/com/mkxvedpro
@@ -19,3 +22,8 @@
 
 
 ## ved_help replaced by ved_ploghelp
+
+
+# --- Revision History ---------------------------------------------------
+# --- Aaron Sloman, Mar 13 2005
+#	             removed -nonwriteable
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/popenv v15.6301-amd64/pop/com/popenv
--- v15.63/pop/com/popenv	2007-09-10 18:00:20.000000000 -0400
+++ v15.6301-amd64/pop/com/popenv	2005-03-11 05:56:54.000000000 -0500
@@ -37,8 +37,7 @@
 if (! $?popcontrib) setenv popcontrib $usepop/pop/packages/contrib
 
 # For system startup
-# Removed AS 10 Sep 2007
-# if (! $?poplib)     setenv poplib ~
+if (! $?poplib)     setenv poplib ~
 setenv popsavelib   $usepop/pop/lib/psv
 setenv popcomppath  ':$poplib:$poplocalauto:$popautolib:$popliblib'
 setenv popsavepath  ':$poplib:$poplocalbin:$popsavelib'
@@ -204,7 +203,12 @@
 
 	case Linux:
 		set XLINK = XT
-		if ( -d /usr/X11R6/lib ) then
+		if ( -d /usr/X11R6/lib64 ) then
+			set XT_DIRS = -L/usr/X11R6/lib64
+			set XM_DIRS = -L/usr/X11R6/lib64
+			# libXm sometimes depends on libXext
+			set XM_FILES = "-lXm -lXt -lXext -lX11"
+		else if ( -d /usr/X11R6/lib ) then
 			set XT_DIRS = -L/usr/X11R6/lib
 			set XM_DIRS = -L/usr/X11R6/lib
 			# libXm sometimes depends on libXext
@@ -268,8 +272,6 @@
 
 
 # --- Revision History ---------------------------------------------------
-# --- Aaron Sloman, 10 Sep 2007
-# 		removed default setting of $poplib
 # --- Aaron Sloman, Jan 16 2005
 #		Changed for V15.6, including introduction of packages dir
 #		New values for poplocal and poplocalbin
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/com/popenv.sh v15.6301-amd64/pop/com/popenv.sh
--- v15.63/pop/com/popenv.sh	2007-09-10 18:01:12.000000000 -0400
+++ v15.6301-amd64/pop/com/popenv.sh	2005-03-11 06:00:02.000000000 -0500
@@ -35,12 +35,11 @@
 export poplocal poplocalauto poplocalbin
 
 # Contrib directory
-popcontrib=${popcontrib=$usepop/pop/contrib}
+popcontrib=${popcontrib=$usepop/pop/packages/contrib}
 export popcontrib
 
 # For system startup
-# Removed AS 10 Sep 2007
-#poplib=${poplib=$HOME}
+poplib=${poplib=$HOME}
 popsavelib=$usepop/pop/lib/psv
 popcomppath=':$poplib:$poplocalauto:$popautolib:$popliblib'
 popsavepath=':$poplib:$poplocalbin:$popsavelib'
@@ -201,9 +200,9 @@
 
 	Linux)
 		XLINK=XT
-		if [ -d /usr/X11R6/lib ]; then
-			XT_DIRS=-L/usr/X11R6/lib
-			XM_DIRS=-L/usr/X11R6/lib
+		if [ -d /usr/X11R6/lib64 ]; then
+			XT_DIRS=-L/usr/X11R6/lib64
+			XM_DIRS=-L/usr/X11R6/lib64
 			# libXm sometimes depends on libXext
 			XM_FILES="-lXm -lXt -lXext -lX11"
 		elif [ -d /usr/X386/lib ]; then
@@ -267,8 +266,6 @@
 
 
 # --- Revision History ---------------------------------------------------
-# --- Aaron Sloman, 10 Sep 2007
-# 		removed default setting of $poplib
 # --- Aaron Sloman, Jan 16 2005
 #		Changed for V15.6, including introduction of packages dir
 #		New values for poplocal and poplocalbin
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/extern/lib/c_core.h v15.6301-amd64/pop/extern/lib/c_core.h
--- v15.63/pop/extern/lib/c_core.h	1999-01-19 21:36:23.000000000 -0500
+++ v15.6301-amd64/pop/extern/lib/c_core.h	2005-03-11 05:30:38.000000000 -0500
@@ -217,7 +217,7 @@
 #define TF_ABS		4
 #define TF_REPEAT	8
 
-extern int pop_timer();
+extern long pop_timer();
 
 /*
  *	Common definitions
Only in v15.63/pop/extern/lib: encoding_euc_jp.so
Only in v15.63/pop/extern/lib: encoding_iso8859_1.so
Only in v15.63/pop/extern/lib: encoding_iso8859_8.so
Only in v15.63/pop/extern/lib: encoding_shift_jis.so
Only in v15.63/pop/extern/lib: encoding_ucs_2.so
Only in v15.63/pop/extern/lib: encoding_utf_8.so
Only in v15.63/pop/extern/lib: libXpw.so
Only in v15.63/pop/extern/lib: libpop.a
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/extern/lib/mklibpop v15.6301-amd64/pop/extern/lib/mklibpop
--- v15.63/pop/extern/lib/mklibpop	1999-01-19 21:36:03.000000000 -0500
+++ v15.6301-amd64/pop/extern/lib/mklibpop	2009-12-24 15:25:18.000000000 -0500
@@ -80,7 +80,8 @@
 rm -f $LIB
 
 # compile files and create library
-$CC -c -O $CC_FLAGS -I$POP_X_INCLUDE *.c && \
+echo $CC -c -g -O $CC_FLAGS -I$POP_X_INCLUDE *.c
+$CC -c -g -O $CC_FLAGS -I$POP_X_INCLUDE *.c && \
 $AR $LIB *.o && \
 $RANLIB
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/extern/lib/pop_timer.c v15.6301-amd64/pop/extern/lib/pop_timer.c
--- v15.63/pop/extern/lib/pop_timer.c	1996-10-23 09:18:00.000000000 -0400
+++ v15.6301-amd64/pop/extern/lib/pop_timer.c	2005-03-11 05:30:39.000000000 -0500
@@ -532,7 +532,7 @@
 	RESTORE_ERRNO;
   }
 
-int pop_timer(flags, ident, handler, tvp)
+long pop_timer(flags, ident, handler, tvp)
 unsigned flags;
 POPWORD ident;
 void (*handler)();
Only in v15.6301-amd64/pop/lib/auto: popuseslist.p-
Only in v15.63/pop/lib/auto: speak_espeak.p
Only in v15.63/pop/lib/auto: speak_flite.p
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/arrays.p v15.6301-amd64/pop/lisp/src/arrays.p
--- v15.63/pop/lisp/src/arrays.p	1996-04-17 07:01:51.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/arrays.p	2009-12-30 17:03:00.000000000 -0500
@@ -545,8 +545,6 @@
 				;;; defaults
 				if len fi_< 16 then
 					16
-				elseif len fi_> 64 then
-					64
 				else
 					len
 				endif
@@ -758,10 +756,10 @@
 			lq1 fi_+ 1 -> lq1;
 			lq2 fi_+ 1 -> lq2;
 			lq3 fi_+ 1 -> lq3;
-			fast_apply(
+			fi_&&(fast_apply(
 				sub_s(lq1, v1),
 				sub_s(lq2, v2),
-				bit_op) -> sub_s(lq3, v3)
+				bit_op), 255) -> sub_s(lq3, v3)
 		endwhile;
 		returnif (hr1 == 0);    /* No bits left over */
 		lq1 fi_<< 3 fi_+ 1 -> lo1;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/chars.p v15.6301-amd64/pop/lisp/src/chars.p
--- v15.63/pop/lisp/src/chars.p	1995-08-07 11:59:05.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/chars.p	2009-12-27 00:32:50.000000000 -0500
@@ -106,7 +106,9 @@
 /* Character conversions */
 
 define character(item);
-	if isintegral(item) then
+        if ischaracter(item) then
+                item
+	elseif isintegral(item) then
 		conscharacter(item)
 	else
 		get_simple_string(item) -> item;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/equals.p v15.6301-amd64/pop/lisp/src/equals.p
--- v15.63/pop/lisp/src/equals.p	1995-08-08 06:50:25.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/equals.p	2009-12-27 00:32:39.000000000 -0500
@@ -194,13 +194,13 @@
 	returnunless ((hi1 fi_- lo1) == (hi2 fi_- lo2)) (false);
 
 	unless b1 do
-		lo1 -> fast_front(Temp_b1);
-		hi1 -> fast_front(Temp_b1_back);
+		0 -> fast_front(Temp_b1);
+		hi1 fi_- lo1 -> fast_front(Temp_b1_back);
 		Temp_b1 -> b1
 	endunless;
 	unless b2 do
-		lo2 -> fast_front(Temp_b2);
-		hi2 -> fast_front(Temp_b2_back);
+		0 -> fast_front(Temp_b2);
+		hi2 fi_- lo2 -> fast_front(Temp_b2_back);
 		Temp_b2 -> b2
 	endunless;
 	returnunless (sys_=(b1, b2)) (false);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/exporti.p v15.6301-amd64/pop/lisp/src/exporti.p
--- v15.63/pop/lisp/src/exporti.p	1996-01-17 11:21:53.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/exporti.p	2009-12-30 18:38:17.000000000 -0500
@@ -95,7 +95,7 @@
 Exporti(@SECOND,                inline_cadr,                    false);
 Exporti(@SEVENTH,               inline_nth(% 7, pair_key %),    false);
 Exporti(@SIXTH,                 inline_nth(% 6, pair_key %),    false);
-Exporti(@SVREF,                 inline_svref,                   false);
+;;; Exporti(@SVREF,                 inline_svref,                   false);
 Exporti(@TENTH,                 inline_nth(% 10, pair_key %),   false);
 Exporti(@THIRD,                 inline_nth(% 3, pair_key %),    false);
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/exports v15.6301-amd64/pop/lisp/src/exports
--- v15.63/pop/lisp/src/exports	1999-08-27 09:01:57.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/exports	2009-12-30 00:04:57.000000000 -0500
@@ -297,7 +297,7 @@
 @GET-DECODED-TIME,               get_decoded_time,                [0 0 9]
 @GET-DISPATCH-MACRO-CHARACTER,   get_dmac_char,                   [2 3 1]
 @GET-INTERNAL-REAL-TIME,         get_internal_real_time,          [0 0 1]
-@GET-INTERNAL-RUN-TIME,          systime,                         [0 0 1]
+@GET-INTERNAL-RUN-TIME,          get_internal_run_time,           [0 0 1]
 @GET-MACRO-CHARACTER,            get_macro_char,                  [1 2 2]
 @GET-OUTPUT-STREAM-STRING,       get_stringout_string,            []
 @GET-PROPERTIES,                 get_properties,                  []
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/hash.p v15.6301-amd64/pop/lisp/src/hash.p
--- v15.63/pop/lisp/src/hash.p	1995-11-29 10:19:25.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/hash.p	2009-12-30 16:15:01.000000000 -0500
@@ -19,7 +19,8 @@
 	dlocal pop_hash_lim;
 
 	#_< syshash(pair_key) >_#;      ;;; Running total kept on stack
-	while ispair(l) do
+	if pop_hash_lim /== 0 then
+	    while ispair(l) do
 		pop_hash_lim fi_- 1 -> pop_hash_lim;
 		fast_apply(fast_destpair(l) -> l, hash_p);
 		unless isinteger(dup()) do
@@ -27,9 +28,10 @@
 		endunless;
 		nonop fi_+ ();
 		returnif(pop_hash_lim == 0);
-	endwhile;
-	if l /== [] then
+	    endwhile;
+	    if l /== [] then
 		fi_+ fast_apply(l, hash_p)
+	    endif
 	endif
 enddefine;
 
@@ -176,7 +178,7 @@
 
 	/* Convert rehash size to power of two */
 	if rehash_size == nil then
-		false
+		1
 	elseif (isinteger(rehash_size) and rehash_size fi_> 0) then
 		1
 	elseif (isdecimal(rehash_size) and rehash_size > 1) then
@@ -194,7 +196,7 @@
 
 	/* Convert rehash threshold (occupancy ratio) into number of entries */
 	if rehash_threshold == nil then
-		false
+		round(size * 0.7)
 	else
 		unless isreal(rehash_threshold)
 		and rehash_threshold >= 0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/inlines.p v15.6301-amd64/pop/lisp/src/inlines.p
--- v15.63/pop/lisp/src/inlines.p	1996-01-17 11:20:50.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/inlines.p	2009-12-30 18:35:25.000000000 -0500
@@ -356,7 +356,7 @@
 	inline_rplaca   =   Inline_any(% fast_rplaca, 2 %),
 	inline_rplacd   =   Inline_any(% fast_rplacd, 2 %),
 	inline_schar    =   Inline_any(% fast_schar, 2 %),
-	inline_svref    =   Inline_any(% fast_subscrv0, 2 %), /* see note below */
+;;;	inline_svref    =   Inline_any(% fast_subscrv0, 2 %), /* see note below */
 	inline_char_code=   Inline_any(% fast_char_code, 1 %),
 	inline_code_char=   Inline_any(% fast_code_char, 1 %),
 	inline_char_int =   Inline_any(% fast_char_code, 1 %),
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/itemise.p v15.6301-amd64/pop/lisp/src/itemise.p
--- v15.63/pop/lisp/src/itemise.p	1995-08-25 10:56:52.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/itemise.p	2009-12-27 00:31:54.000000000 -0500
@@ -124,17 +124,6 @@
 enddefine;
 
 
-define skipform();
-	;;; used when *READ-SUPPRESS* is true
-	if is_char_mac(lextype) then
-		lextype()
-	else
-		until (lexget(), AT_TOKEN_END) do enduntil, lexput();
-		nil
-	endif
-enddefine;
-
-
 define digit();
 	lvars n;
 	lexchar;
@@ -263,12 +252,32 @@
 			true -> lex_eof_error;          ;;; force an error
 			eof()
 		endif;
-		lexchar
+                if read_suppress == nil then
+		    lexchar
+                endif
 	enduntil;
 	false ->> lex_redo -> lexnum
 enddefine;
 
 
+define skipform();
+	;;; used when *READ-SUPPRESS* is true
+	if is_char_mac(lextype) then
+		lextype()
+	else
+		repeat
+                   if lextype == multiple_escape then
+                       multiple_escape()
+                   elseif lextype == single_escape then
+                       lexget()
+                   endif;
+                   lexget();
+                   quitif(AT_TOKEN_END);
+                endrepeat, lexput();
+		nil
+	endif
+enddefine;
+
 define colon();
 	lvars pkg;
 	if lexpkg then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/print.p v15.6301-amd64/pop/lisp/src/print.p
--- v15.63/pop/lisp/src/print.p	1995-11-29 10:21:19.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/print.p	2009-12-26 19:31:24.000000000 -0500
@@ -355,7 +355,13 @@
 
 define lconstant Escape_pr(s);
 	cucharout(`|`);
-	appdata(s, cucharout);
+	appdata(s, 
+                procedure(c);
+                    if c = `\\` or c = `|` then
+                        cucharout(`\\`);
+                    endif;
+                    cucharout(c);
+                endprocedure);
 	cucharout(`|`);
 enddefine;
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/specs.p v15.6301-amd64/pop/lisp/src/specs.p
--- v15.63/pop/lisp/src/specs.p	1995-08-07 10:15:53.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/specs.p	2009-12-30 21:34:48.000000000 -0500
@@ -8,15 +8,20 @@
 
 lisp_compile_mode;
 
+#include sysdefs.ph
+
 section $-lisp;
 
 /* Field spec <-> element type conversions */
 
 lconstant Word_spec_to_int
-	= newproperty([[uint     32]
+	= newproperty([
+                                   [ulong    64]
+                                   [long    -64]
+                                   [uint     32]
 				   [int     -32]
-				   [ulong    32]
-				   [long    -32]
+				   [uint    32]
+				  ;;;  [long    -32]
 				   [pint    -30]
 				   [ushort   16]
 				   [short   -16]
@@ -25,8 +30,11 @@
 
 
 lconstant Int_spec_to_word
-	= newproperty([[-32     long]
-				   [32      ulong]
+	= newproperty([
+                                   [64    ulong]
+                                   [-64    long]
+                                   [-32     int]
+				   [32      uint]
 				   [-30     pint]
 				   [-16     short]
 				   [16      ushort]
@@ -133,17 +141,32 @@
 /* Key <-> spec/element-type conversions */
 
 lconstant Spec_to_key
-	= newproperty([[1           ^bitvector_key]
-				   [character   ^string_key]
-				   [short       ^shortvec_key]
-				   [int         ^intvec_key]
-				   [long        ^intvec_key]
-				   [full        ^vector_key]], 31, false, true);
+    = newproperty([[1           ^bitvector_key]
+                   [character   ^string_key]
+                   [byte        ^bytevec_key]
+                   [sbyte       ^sbytevec_key]
+                   [ushort      ^ushortvec_key]
+                   [short       ^shortvec_key]
+                   [uint        ^untvec_key]
+                   [int         ^intvec_key]
+                   [ulong       ^ulongvec_key]
+                   [long        ^longvec_key]
+                   [full        ^vector_key]], 31, false, true);
 
 
 define spec_->_key(spec) -> key;
-	if isintegral(spec) and abs(spec) > 32 then
-		"full" -> spec
+	if isintegral(spec) then
+            if abs(spec) > 64 then
+		"full"
+            elseif abs(spec) > 32 then
+               if spec > 0 then "ulong" else "long" endif;
+            elseif abs(spec) > 16 then
+               if spec > 0 then "uint" else "int" endif;
+            elseif abs(spec) > 8 then
+               if spec > 0 then "ushort" else "short" endif;
+            elseif abs(spec) > 1 then
+               if spec > 0 then "byte" else "sbyte" endif;
+            else spec endif -> spec;
 	elseif spec == "decimal" then
 		"sfloat" -> spec
 	elseif spec == "ddecimal" then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/lisp/src/time.p v15.6301-amd64/pop/lisp/src/time.p
--- v15.63/pop/lisp/src/time.p	1995-11-29 10:21:51.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/time.p	2009-12-30 08:24:25.000000000 -0500
@@ -11,7 +11,7 @@
 section $-lisp;
 
 
-constant internal_time_units_per_sec = 100;
+constant internal_time_units_per_sec = 1000000;
 
 constant _1900_1970 = 70 * 365 * 86400 /* 17 leap years */ + (17 * 86400);
 
@@ -20,9 +20,12 @@
 	sys_real_time() + _1900_1970
 enddefine;
 
+define get_internal_run_time();
+    systime()*10000 ;;; internal_time_units_per_sec/100
+enddefine;
 
 define get_internal_real_time();
-	sys_real_time() * internal_time_units_per_sec
+    sys_microtime()
 enddefine;
 
 
Only in v15.6301-amd64/pop/obj: old
Only in v15.63/pop/obj: src.olb
Only in v15.63/pop/obj: src.wlb
Only in v15.63/pop/obj: vedsrc.olb
Only in v15.63/pop/obj: vedsrc.wlb
Only in v15.63/pop/obj: xsrc.olb
Only in v15.63/pop/obj: xsrc.wlb
Only in v15.63/pop/packages/com: mkrhino
Only in v15.63/pop/packages/com: popbin
Only in v15.63/pop/packages/com: poplogout.sh-dud
Only in v15.6301-amd64/pop/packages/contrib: AATARBUILD2004-10-10
Only in v15.6301-amd64/pop/packages/contrib: AATARFILE.LATEST
Only in v15.6301-amd64/pop/packages/contrib: CONTENTS
Only in v15.6301-amd64/pop/packages/contrib: COPYRIGHT
Only in v15.6301-amd64/pop/packages/contrib: ai_through_search
Only in v15.6301-amd64/pop/packages/contrib: contrib.news
Only in v15.6301-amd64/pop/packages/contrib: lisp
Only in v15.6301-amd64/pop/packages/contrib: nlp_book
Only in v15.6301-amd64/pop/packages/contrib: pml
Only in v15.6301-amd64/pop/packages/contrib: pop11
Only in v15.6301-amd64/pop/packages/contrib: prolog
Only in v15.6301-amd64/pop/packages/contrib: pwm
Only in v15.6301-amd64/pop/packages/contrib: ved
Only in v15.6301-amd64/pop/packages/contrib: x
Only in v15.63/pop/packages/master: README
Only in v15.6301-amd64/pop/packages/neural/bin: alpha
Only in v15.6301-amd64/pop/packages/neural/bin: axposf
Only in v15.6301-amd64/pop/packages/neural/bin: sun
Only in v15.6301-amd64/pop/packages/neural/bin: sun4r5
Only in v15.6301-amd64/pop/packages/neural/bin: sun4r5.old
Only in v15.63/pop/packages/newc_dec: auto
Only in v15.63/pop/packages/newkit: AREADME.txt
Only in v15.63/pop/packages/newkit/prb: AREADME.txt
Only in v15.6301-amd64/pop/packages/newkit/prb: README
Only in v15.63/pop/packages/newkit/sim: AREADME.txt
Only in v15.6301-amd64/pop/packages/popvision: AATARBUILD-2005-01-07
Only in v15.6301-amd64/pop/packages/popvision: AATARBUILD-2006-03-29
Only in v15.6301-amd64/pop/packages/popvision: AATARFILE.LATEST
Only in v15.63/pop/packages/popvision: AATARFILE.LATEST-090220
Only in v15.63/pop/packages/prb: AREADME.txt
Only in v15.6301-amd64/pop/packages/prb: README
Only in v15.63/pop/packages/rclib: AREADME.txt
Only in v15.6301-amd64/pop/packages/rclib: COPYRIGHT
Only in v15.6301-amd64/pop/packages/rclib: README
Only in v15.63/pop/packages/rcmenu: hyper.pdf
Only in v15.6301-amd64/pop/packages/rcmenu: hyper.ps.gz
Only in v15.63/pop/packages/sim: AREADME.txt
Only in v15.63/pop/packages/teaching: AREADME.txt
Only in v15.63/pop/packages/teaching/auto: haiku_speak.p
Only in v15.63/pop/packages/teaching/lib: eliza_speak.p
Only in v15.6301-amd64/pop/packages/teaching/lib: elizaprog.p-
Only in v15.63/pop/packages/teaching/lib: rhino.p
Only in v15.6301-amd64/pop/packages/vedlatex/auto: findcite.p.orig
Only in v15.63/pop/packages/vedutils: AREADME.txt
Only in v15.6301-amd64/pop/pop: .nfs00000000001c45f000000001
Only in v15.63/pop/pop: AS-build-on-CentOS-5.2-2009-07-04
Only in v15.63/pop/pop: AS-re-packaged-2009-07-04
Only in v15.63/pop/pop: basepop11
Only in v15.63/pop/pop: basepop11.stb
Only in v15.63/pop/pop: clisp
Only in v15.63/pop/pop: copybasepop11
Binary files v15.63/pop/pop/corepop and v15.6301-amd64/pop/pop/corepop differ
Only in v15.63/pop/pop: corepop11
Only in v15.6301-amd64/pop/pop: cpu.dat
Only in v15.63/pop/pop: doc
Only in v15.63/pop/pop: im
Only in v15.63/pop/pop: newpop.psv
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/pop/pgcomp v15.6301-amd64/pop/pop/pgcomp
--- v15.63/pop/pop/pgcomp	2007-12-25 17:23:46.000000000 -0500
+++ v15.6301-amd64/pop/pop/pgcomp	1994-12-16 11:33:14.000000000 -0500
@@ -1,5 +1,4 @@
-#!/bin/bash
-##Altered 25 Dec 2007, to use 'bash' instead of 'sh'
+#!/bin/sh
 # --- Copyright University of Sussex 1994. All rights reserved. ----------
 # File:             C.unix/pop/pgcomp
 # Purpose:          Compile POPLOG source files (.p or .s)
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/pop/pglibr v15.6301-amd64/pop/pop/pglibr
--- v15.63/pop/pop/pglibr	2007-12-25 17:24:12.000000000 -0500
+++ v15.6301-amd64/pop/pop/pglibr	1993-07-09 23:34:47.000000000 -0400
@@ -1,5 +1,4 @@
-#!/bin/bash
-##Altered 25 Dec 2007, to use 'bash' instead of 'sh'
+#!/bin/sh
 # --- Copyright University of Sussex 1993. All rights reserved. ----------
 # File:             C.unix/pop/pglibr
 # Purpose:          Update POPLOG module library
